package de.intevation.flys.artifacts.states.fixation;

import java.util.Collection;

import org.w3c.dom.Element;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;
import de.intevation.artifacts.common.utils.XMLUtils;
import de.intevation.flys.artifacts.math.fitting.Function;
import de.intevation.flys.artifacts.math.fitting.FunctionFactory;
import de.intevation.flys.artifacts.states.DefaultState;

/**
 * @author <a href="mailto:raimund.renkert@intevation.de">Raimund Renkert</a>
 */
public class FunctionSelect extends DefaultState {

    /**
     * The default constructor that initializes an empty State object.
     */
    public FunctionSelect() {
    }

    @Override
    public String getUIProvider() {
        return "fix.functionselect";
    }

    @Override
    protected Element[] createItems(
        XMLUtils.ElementCreator ec,
        Artifact                artifact,
        String                  name,
        CallContext             context)
    {
        FunctionFactory ff = FunctionFactory.getInstance();
        Collection<Function> fc = ff.getFunctions();
        Element[] functions = new Element[fc.size()];

        int j = 0;
        for (Function f: fc) {
            String n = f.getName();
            String d = f.getDescription();
            functions[j] = createItem(ec, new String[] {d, n});
            j++;
        }

        return functions;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
